'Form4.bas
'
'The program below - Form4.bas - shows how to create a menu on a form or dialog using a resource file.
'Compile Tested with PB 8.01
'
'Form4.rc   Directions For Creating Menu For Form4.bas
'
'An easy way to get a menu on a form/dialog is to create a
'resource file as seen below.
'
'1) Open new file in PowerBASIC and paste the following:
'
'[CODE]
'#include "resource.h"
'
'Form4 MENU
'{
' POPUP "&File"
' {
'  MENUITEM "&Open...",               1000
'  MENUITEM "&Save...",               1002
'  MENUITEM SEPARATOR
'  MENUITEM "E&xit",                  1004
' }
' POPUP "&Help"
' {
'  MENUITEM "&Help...",               1006
'  MENUITEM "&About Form6...",        1008
' }
'}
'[/CODE]

'2) Save file as Form4.rc;
'
'3) Compile within PBEdit by clicking little gear or Compile
'   from menu.  You'll quickly in succession be presented
'   with two messages, the first informing you that Form4.res
'   was successfully created, then that Form4.pbr was success-
'   fully created;
'
'4) Copy Form4.bas to another PBEdit 'New' window, and save
'   in same folder/directory as Form4.rc;
'
'5) Compile and run Form4.bas.

'[CODE]
'Form4.bas
#Compile Exe
#Include "Win32api.inc"
#Resource "Form4.pbr"
%IDM_OPEN     =  1000      'These are known as equates and serve as 'proxy' identifiers for the objects/windows
%IDM_SAVE     =  1002      'they are associated with.  Note, for example, the nineth parameter in the Create
%IDM_EXIT     =  1004      'Window Call below under WM_CREATE for the button control - hBtn=CreateWindow(...).
%IDM_HELP     =  1006
%IDM_ABOUT    =  1008
%IDC_BUTTON   =  1010

Function WndProc(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Select Case As Long wMsg
    Case %WM_CREATE                     'The WM_CREATE message occurs once for each window.  It is an ideal
      Local hBtn As Dword               'place to create child windows of the main Form/Dialog of your program
      Local hInst As Dword              'such as buttons, labels, text boxes, list boxes, combo boxes, etc.
      hInst=GetWindowLong(hWnd,%GWL_HINSTANCE)
      hBtn=CreateWindow _
      ( _
        "button", _                     'We're creating a window of the predefined Window Class 'Button'.
        "Command Button", _             'This is the caption of the window (button caption).
        %WS_CHILD Or %WS_VISIBLE, _     'Its a 'child' of the main window and we want to see it.
        85, _                           'x coordinate on main window of upper left corner of button.
        40, _                           'y coordinate on main window of upper left corner of button.
        140, _                          'button width
        30, _                           'button height
        hWnd, _                         'Parent of button (main window)
        %IDC_BUTTON, _                  'Control identifier of button, that is, %IDC_BUTTON = 1010
        hInst, _                        'Program instance handle
        Byval 0 _                       'This is a very useful parameter but we're not using it here
      )
    Case %WM_COMMAND                    'When you interact in any way with child windows on your
      Select Case LoWrd(wParam)         'Form/Dialog, or the menu, WM_COMMAND messages are sent by
        Case %IDM_OPEN                  'Windows to the parent of the child windows.  The particular
          MsgBox("You Clicked File >> Open File!")    'control/child window sending the message can
        Case %IDM_SAVE                                'be differentiated through the Lowrd(wParam),
          MsgBox("You Clicked File >> Save File!")    'as this number will be the control identifier
        Case %IDM_EXIT                                'associated with the control when it was
          MsgBox("Send A Message To Windows To Close The Application.")  'created in the Create
          Call SendMessage(hWnd,%WM_CLOSE,0,0)                           'Window Call.
        Case %IDM_HELP
          MsgBox("You Clicked Help >> Help!")
        Case %IDM_ABOUT
          MsgBox("You Clicked Help >> About...")
        Case %IDC_BUTTON
          MsgBox("You Clicked The Command Button!")
      End Select
      WndProc=0
      Exit Function
    Case %WM_CLOSE
      If MsgBox("Do You Wish To Exit This Program?", %MB_YESNO, "MsgBox() Function Demo") = %IDYES  Then
         Call DestroyWindow(hWnd)
      End If                             'Note the two ways that this program can receive a WM_CLOSE
      WndProc=0                          'message.  The first way is if you click the 'x' close button
      Exit Function                      'in the program's title bar.  Windows will automatically send
    Case %WM_DESTROY                     'this message in that case.  But we 'manually' SendMessage()
      Call PostQuitMessage(0)            'a WM_CLOSE in the Case above under IDM_EXIT from the Exit
      WndProc=0                          'menu.
      Exit Function
  End Select                                        'Another very important point to grasp that is
                                                    'somewhat subtle is that when we handle a message
  WndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)    'we do an Exit Function.  If we don't handle a
End Function                                        'message DefWindowProc() gets called!


Function WinMain(ByVal hIns As Long, ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr, ByVal Is As Long) As Long
  Local winclass As WndClassEx
  Local szAppName As Asciiz*8
  Local hMainWnd As Dword
  Local Msg As tagMsg

  szAppName="Form4"
  winclass.lpszClassName=VarPtr(szAppName)              : winclass.lpfnWndProc=CodePtr(WndProc)
  winclass.cbSize=SizeOf(winclass)                      : winclass.style=%CS_HREDRAW Or %CS_VREDRAW
  winclass.cbClsExtra=0                                 : winclass.cbWndExtra=0
  winclass.hInstance=hIns                               : winclass.hIcon=LoadIcon(%NULL,ByVal %IDI_APPLICATION)
  winclass.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)  : winclass.hbrBackground=%COLOR_BTNFACE+1
  winclass.lpszMenuName=VarPtr(szAppName)               : winclass.hIconSm=LoadIcon(hIns, ByVal %IDI_APPLICATION)
  Call RegisterClassEx(winclass)
  hMainWnd=CreateWindowEx(0,szAppName,"Form4",%WS_OVERLAPPEDWINDOW,350,400,325,225,0,0,hIns,ByVal 0)
  ShowWindow hMainWnd,Is
  UpdateWindow hMainWnd
  While GetMessage(Msg,%NULL,0,0)
    Call TranslateMessage(Msg)
    Call DispatchMessage(Msg)
  Wend
'
  Function=msg.wParam
End Function
'[/CODE]
